# AVRNerd --- ATmega328P Programmer on FT232RL
This program consists of minimal devices --- FT232RL, a FTDI IC supporting BitBang mode.

This programmer supports the following functions:
- Flashing Intel Hex file
- Changing fuse bits(lfuse, hfuse, efuse. Not including lock bits.)
- Erasing all the flash & lock bits
The name is after the famous flashing progam `avrdude`.
I'm very sorry but no microcomputer other than **ATMega328P** is supported on this program.

# Requirements for building
- g++(clang++)
- FTD2XX library

To build this program just execute `make` in the root directory of this repository. After creating some object files, you can use `./avrnerd` on your terminal.

# Execution
## options
If there is no option, `avrnerd` only prints the device ID and fuse bits.

### Flashing and Erasing
To flash program you should type `-w ~/path/to/hex`. This command just write the program to the AVR chip. To erase you should type `-e` manually. In order to erase the chip and flash the program, you should type:

```bash
$ avrnerd -e -w ~/path/to/hex/
```

The order of `-w ~/path/to/hex` and `-e` doesn't make effect to this program. If both are designated, `avrnerd` always flashes the MCU program after erasing.

### Fuse Bits
`-lf` option writes the **LOW** fuse bits. The hexadecimal number must follow `-lf` divided by one space. Please do not forget to add the prefix `0x` before the number. The following is right:

```bash
$ avrnerd -lf 0xC2 # just "C2" is not correct
```

`-hf` option writes **HIGH** fuse bits and `-ef` writes **EXTENDED** fuse bits. The usage is the same as the descriptions below.

# License
MIT