#include "global.hpp"
void exit_app(int);
uint8_t get_hexstring_as_number(char *str) {
	uint8_t ret = 0;
	if( str[0] == '0' && (str[1] == 'x' || str[1] == 'X') ) {
		ret = c_num(toupper(str[2])) * 16 + c_num(toupper(str[3]));
	}else{
		printf("The designated fuse value is invaild.\n");
		printf("Set the prefix 0x or 0X.\n");
		exit_app(1);
	}
	return ret;
}

void parse_argument(int argc, char **argv) {
	arg_opt = 0x00;
	for(int i=1; i<argc; i++) {
		if( strcmp(argv[i], "-h") == 0 ) {
			arg_opt |= ARG_HELP;
		}
		else if( strcmp(argv[i], "-e") == 0 ) {
			arg_opt |= ARG_ERASE;
		}
		else if( strcmp(argv[i], "-w") == 0 ) {
			arg_opt |= ARG_FLASH;
			filename = (i+1 < argc) ? argv[i+1] : NULL;
			i++;
		}else if( strcmp(argv[i], "-lf") == 0 ) {
			arg_opt |= ARG_LFUSE;
			if( i + 1 < argc ) {
				fuse_val[FUSE_L] = get_hexstring_as_number(argv[i+1]);
			}
			i++;
		}else if( strcmp(argv[i], "-hf") == 0 ) {
			arg_opt |= ARG_HFUSE;
			if( i + 1 < argc ) {
				fuse_val[FUSE_H] = get_hexstring_as_number(argv[i+1]);
			}
			i++;
		}else if( strcmp(argv[i], "-ef") == 0 ) {
			arg_opt |= ARG_EFUSE;
			if( i + 1 < argc ) {
				fuse_val[FUSE_E] = get_hexstring_as_number(argv[i+1]);
			}
			i++;
		}else if( strcmp(argv[i], "-r") == 0 ) {
			arg_opt |= ARG_READ;
		}
	}
}
