#pragma once

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <inttypes.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <fstream>
#include <string>

#include <ftd2xx.h>
#include "comm.hpp"
#include "hex.hpp"
#include "data.hpp"
#include "argument.hpp"

#define PIN_TX_Pos 0
#define PIN_RX_Pos 1
#define PIN_RTS_Pos 2
#define PIN_CTS_Pos 3
#define PIN_DTR_Pos 4
#define PIN_DSR_Pos 5
#define PIN_DCD_Pos 6
#define PIN_RI_Pos 7

#define bis(n) (1 << (n))
#define PIN(x) bis(PIN_##x##_Pos)
#define PIN_TX  0x01
#define PIN_RX  0x02
#define PIN_RTS 0x04
#define PIN_CTS 0x08
#define PIN_DTR 0x10
#define PIN_DSR 0x20
#define PIN_DCD 0x40
#define PIN_RI  0x80

#define BUFSIZE 50000

#define c_num(x) (((x) > '9') ? (x) - '0' - 7 : (x) - '0')
extern FT_HANDLE handle;
extern uint32_t bytes;
extern UCHAR data[64 * 2];
extern ULONG written;
extern uint8_t arg_opt;
extern char *filename;
extern uint8_t fuse_val[3];

enum {
	FUSE_L = 0, FUSE_H = 1, FUSE_E = 2
};

enum Instrcution {
	BEGIN_PROGRAMMING = 0xAC530000, ERASE_CHIP = 0xAC800000,
	READ_FLASH_HIGH = 0x28000000, READ_FLASH_LOW = 0x20000000,
	READ_DEVID = 0x30000000, READ_HFUSE = 0x58080000,
	READ_LFUSE = 0x50000000, READ_EFUSE = 0x50080000,
	WRITE_FLASH_PAGE = 0x4C000000, SET_FLASH_PAGE_HIGH = 0x48000000,
	SET_FLASH_PAGE_LOW = 0x40000000, IS_BUSY = 0xF0000000,
	WRITE_LFUSE = 0xACA00000, WRITE_HFUSE = 0xACA80000,
	WRITE_EFUSE = 0xACA40000
};
