#include "global.hpp"

static int strreplace(char *str, char key, char after) {
	int p = 0;
	int cnt = 0;
	while( str[p] != '\0' ) {
		if( str[p] == key ) {
			str[p] = after;
			cnt++;
		}
		p++;
	}
	return cnt;
}

int parse() {
	static const char MARK_LEN = 1;
	static const char REC_LEN = 2;
	static const char LOAD_OFFSET_LEN = 4;
	static const char RECTYPE_LEN = 2;
	static const char CHKSUM_LEN = 2;

	std::ifstream ifs(filename);
	if( ifs.fail() ) {
		printf("Failed to open file %s.\n", filename);
		return 0;
	}

	std::string str;
	while( std::getline(ifs, str) ) {
		char buf[str.size() + 1];
		strcpy(buf, str.c_str());
		strreplace(buf, '\n', '\0');
		strreplace(buf, '\r', '\0');

		int line_len = strlen(buf);
		// start parsing
		if( buf[0] != ':' ) {
			return 0;
		}
		const int rec_len = c_num(buf[1]) * 16 + c_num(buf[2]);
		__attribute__((unused)) const int load_offset = c_num(buf[3]) * 16*16*16 + c_num(buf[4]) * 16*16 + c_num(buf[5]) * 16 + c_num(buf[6]);
		__attribute__((unused)) const int rectype = c_num(buf[7]) * 16 + c_num(buf[8]);

		// printf("line_len: %d:: len: %d, off: %d, type: %d\n", line_len, rec_len, load_offset, rectype);
		const int actual_data_len_char = line_len - MARK_LEN - REC_LEN - LOAD_OFFSET_LEN - RECTYPE_LEN - CHKSUM_LEN;
		// printf("%d, %d\n", rec_len, actual_data_len_char);
		// printf("Line_len: %d\n", line_len);
		if( rec_len != actual_data_len_char/2 ) {
			return 0;
		}
		// printf("OK\n");
		int data[rec_len];
		for(int i=0; i<rec_len; i++) {
			data[i] = c_num(buf[2*i+9]) * 16 + c_num(buf[2*i+10]);
		}
		// for(int i=0; i<rec_len; i++) {
		// 	printf("%X\n", data[i]);
		// }
		int chksum = c_num(buf[9+rec_len*2]) * 16 + c_num(buf[9+rec_len*2+1]);
		int sum = 0;
		for(int i=0; i<rec_len+4; i++){
			sum += c_num(buf[2*i+1]) * 16 + c_num(buf[2*i+2]);
		}
		if( ((-(sum & 0xFF)) & 0xFF) != chksum ) {
			return 0;
		}
	}
	// printf("sum: %02X, chksum: %02X\n", (-(unsigned char)(sum & 0xFF)) & 0xFF, chksum);
	return 1;
}
